local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent", function(self, event, addon)
	if IsAddOnLoaded("Blizzard_TradeSkillUI") and not IsAddOnLoaded("OneClickEnchantScroll") then
		local useFrame = CraftFrame or TradeSkillFrame
		local oldfunc = TradeSkillFrame_SetSelection
		if (ATSWFrame ~= nil) then useFrame = ATSWFrame end
		local button = CreateFrame("Button", "TradeSkillCreateScrollButton", useFrame, "UIPanelButtonTemplate")--"MagicButtonTemplate")
		button:SetNormalFontObject("GameFontNormalSmall")
		if (ATSWFrame ~= nil) then
			button:SetWidth(125)
			button:SetHeight(19)
			button:SetPoint("TOPLEFT", ATSWFrame, "TOPLEFT", 80, -14)
		else
			button:SetWidth(125)
			button:SetHeight(24)
			button:SetPoint("TOPRIGHT", TradeSkillCreateButton, "TOPLEFT", -4, 1)
		end
		if SkilletFrame then
			local frame = Skillet:AddButtonToTradeskillWindow(button)
			useFrame = frame;
		end
		button:SetScript("OnClick", function()
			DoTradeSkill(TradeSkillFrame.selectedSkill)
			UseItemByName(38682)
		end)

		function TradeSkillFrame_SetSelection(id)
			oldfunc(id)
			local skillName, _, _, _, altVerb = GetTradeSkillInfo(id)
			if IsTradeSkillGuild() or IsTradeSkillLinked() then
				button:Hide()
			elseif altVerb and CURRENT_TRADESKILL == GetSpellInfo("Enchanting") then --7411) then
				button:Show()
				local creatable = 1
				if not skillName then
					creatable = nil
				end
				local scrollnum = GetItemCount("Enchanting Vellum")--38682)
				TradeSkillCreateScrollButton:SetText("Vellum".." ("..scrollnum..")")
				if scrollnum == 0 then
					creatable = nil
				end
				for i = 1, GetTradeSkillNumReagents(id) do
					local _, _, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(id, i)
					if playerReagentCount < reagentCount then
						creatable = nil
					end
				end
				if creatable then
					TradeSkillCreateScrollButton:Enable()
				else
					TradeSkillCreateScrollButton:Disable()
				end
			else
				button:Hide()
			end
		end
	end
end)